/**** Constants ****/
/* Maze Map */
#define UNKNOWN -4
#define GOAL -3
#define START -2
#define WALL -1
#define ROUTE 0

/* Direction */
#define DIR_UP 0
#define DIR_RIGHT 1
#define DIR_DOWN 2
#define DIR_LEFT 3

/* Status */
#define STAT_STEP1 1
#define STAT_SEARCH 2
#define STAT_STEP2 3
#define STAT_DONE 4

/* Next Step */
#define GO_LEFT -2
#define TURN_LEFT -1
#define GO_FORWARD 0
#define TURN_RIGHT +1
#define GO_RIGHT +2
#define GO_BACK -3
#define DONE -100

/* X11 */
#define VIEWSIZE 300
#define MAPSIZE 300
#define TIMEOUT 500

/* Data Types */
typedef struct _ViewInfo {
  int left;	/* Status of Your Left Side */
  int front;	/* Status of Your Front Side */
  int right;	/* Status of Your Right Side */
  int back;	/* Status of Your Back Side */
  int current;	/* Status of Your Location */
  int dir;	/* Direction */
  int x, y;	/* Location */
} ViewInfo;

/**** Variables ****/
/* Maze Map */
extern int HSize;
extern int VSize;
extern int StartX;
extern int StartY;

/* Increments for Next Direction */
extern int DirX[];
extern int DirY[];

/* Information for Current Location */
extern ViewInfo View;

/**** Functions ****/
/* Show Maze */
void Show(int **Maze);

/* Get ViewInfo */
void GetViewInfo(ViewInfo *info, int **Maze, int PosX, int PosY, int Dir);

/* Write ViewInfo into Maze Map */
void SetViewInfo(ViewInfo *info, int **Maze);

/* Get New ViewInfo after Next Action */
/*
	return 0 if success
	return -1 if failed
*/
int GetNextViewInfo(ViewInfo *info, int **Maze, int next);

/**** User Functions ****/
/* Initialize */
void Init();

/* Decide Next in Step1 */
int Step1FindNext();

/* Searching Optimum Path */
void SearchPath();

/* Decide Next in Step1 */
int Step2FindNext();

